# mblasters.tcl v1.1 by domsen <domsen@domsen.org> (c)2oo4
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das  tcl  liest  die www.masterblasters.info  news  aus  und gibt  sie wieder,
# gleich mit dem link zum eigentlichen artikel. per trigger lassen sich auch die
# letzten X news von hand auslesen.
#
# requested by: mb`teddysjam
#
# v1.1 - sourcecodechange
#
# mblasterstrigger - der trigger auf den der bot reagiert (public und message)
# mblasterslimit - maximum der news die auf befehl geposted werden
# mblastersnewspost  - 1 fr newsposting, 0 fr keines
# mblasterschans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# mblastersnewspostlimit - maximum der news die geposted werden
# ismblastershub  - legt fest ob der bot newshub ist oder nicht
# mblastersleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set mblasterstrigger ".mblasters"
set mblasterschans ""
set mblasterslimit "10"
set mblastersnewspostlimit "3"
set mblastersnewspost "1"
set ismblastershub "1"
set mblastersleafs "news"

####### ende der config #############

bind msg - $mblasterstrigger msg_mblasters
bind pub - $mblasterstrigger pub_mblasters
bind time - "?? * * * *" mblasterscheck

proc sendmblastersnews { arg } {
global mblastersleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $mblastersleafs] [string tolower $bot]] != -1)} {
putbot $bot "mblasters: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc mhtml { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
regsub -all "&lt;" $text "<" text
regsub -all "&gt;" $text ">" text
regsub -all "&amp;" $text "&" text
return $text
}

proc mblasterscheck {nick uhost hand chan arg} {
global mblasterschans mblastersnewspost ismblastershub mblastersnewspostlimit
set counter 0
if {$mblastersnewspost == 1 } {
putlog "mblasters: suche nach neuer newsline"
set mblasterslastnews "none"
if {[file exists mblasters.hdl]} {
set temp [open "mblasters.hdl" r]
set mblasterslastnews "[gets $temp]"
if {$mblasterslastnews == ""} { set mblasterslastnews "none" }
close $temp
}
set temp [open "mblasters.hdl" w+]
if {[catch {set sock [socket www.masterblasters.info 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /mb/?lid=archive HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.masterblasters.info"
puts $sock ""
flush $sock
set counter 0
set checker 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "3b.gif" $bl] != -1 } { set checker 1 }
if {[string first "3c.gif" $bl] != -1 } { set checker 0 }
if { $checker == 1 && [string first "lid=news" $bl] != -1 } {
set newsline [string range $bl [shrink + 2 "'>" 0 $bl] [shrink - 1 "</" 0 $bl]]
set link www.masterblasters.info/mb/[string range $bl [shrink + 1 "'" 0 $bl] [shrink - 1 "'>" 0 $bl]]
puts $temp "[mhtml $newsline] <$link>"
}}}
close $sock ; close $temp
if {$mblasterslastnews == "none" } { putlog "mblasters: headlinefile created" ; return 0 }
set temp [open "mblasters.hdl" r]
while { [eof $temp] != 1 } {
set mblastersneunews [gets $temp]
if {($mblasterslastnews == $mblastersneunews) || ($counter == $mblastersnewspostlimit)} { close $temp;return 0 }
incr counter
foreach chan [channels] {
if {$mblasterschans == "" } { putserv "privmsg $chan :(neue masterblasters newsline) $mblastersneunews" }
if {$mblasterschans != "" } {
if {([lsearch -exact [string tolower $mblasterschans] [string tolower $chan]] != -1) || ($mblasterschans == "")} {putserv "privmsg $chan :(neue mblasters newsline) $mblastersneunews"}
}
if { $ismblastershub == "1" } { sendmblastersnews $mblastersneunews }
}}}}


proc mblastersnews {target limit} {
if {[catch {set sock [socket www.masterblasters.info 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /mb/?lid=archive HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.masterblasters.info"
puts $sock ""
flush $sock
set counter 0
set checker 0
while {[eof $sock] != 1} {
if {[string first "3b.gif" $bl] != -1 } { set checker 1 }
if {[string first "3c.gif" $bl] != -1 } { set checker 0 }
if { $checker == 1 &&[string first "lid=news" $bl] != -1 } {
set newsline [string range $bl [shrink + 2 "'>" 0 $bl] [shrink - 1 "</" 0 $bl]]
set link www.masterblasters.info/mb/[string range $bl [shrink + 1 "'" 0 $bl] [shrink - 1 "'>" 0 $bl]]
putserv "privmsg $target :[incr counter] [mhtml $newsline] $link"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_mblasters { nick uhost hand arg } { global mblasterslimit ; mblastersnews $nick $mblasterslimit }
proc pub_mblasters { nick uhost hand chan arg } { global mblasterschans mblasterslimit ; if {([lsearch -exact [string tolower $mblasterschans] [string tolower $chan]] != -1) || ($mblasterschans == "")} { mblastersnews $nick $mblasterslimit }}

putlog "*** mblasters.tcl v1.1 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]